package net.pricefx.common.apibuilder.calculationflowaction;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public final class MethodInvocationRecord {

	private MethodInvocationRecord(String fullName,  Object ... arguments) {
		this.fullName = fullName;
		if (arguments == null || arguments.length == 0) 
			this.arguments = Collections.emptyList();
		else
			this.arguments = Collections.unmodifiableList(Arrays.asList(arguments));
	}
	
	private final String fullName;
	private final List<Object> arguments;
	
	@Override public String toString() { return fullName; }

	public String fullName() { return fullName; }
	public List<Object> arguments() {return arguments; }
	
	public static MethodInvocationRecord of(String fullName, Object ... arguments) {
		return new MethodInvocationRecord(fullName, arguments);
	}

}