package net.pricefx.formulaengine.optimization;

import net.pricefx.domain.LookupTable;
import net.pricefx.formulaengine.scripting.PublicGroovyAPI;

public interface ModelLookupTablesContextReadOnly {
    /**
     * @param name The name of the {@link LookupTable} owned by this model
     * @return The {@link ModelLookupTable} owned by this model or {@code null} if it doesn't exist
     */
    ModelLookupTable lookupTable(String name);

    /**
     * Represents a {@link LookupTable} owned by a {@link ModelObject}
     */
    interface ModelLookupTable {

        /**
         * @return the uniqueName of the {@link LookupTable} (useful for use in {@link PublicGroovyAPI}).
         * It is composed of the local name of the {@link LookupTable} in the {@link ModelObject} and the typedId of the {@link ModelObject}.
         */
        String uniqueName();

        /**
         * @return the id of the {@link LookupTable}
         */
        long id();
    }
}
