package net.pricefx.logic.core.model;

import com.fasterxml.jackson.databind.node.ObjectNode;
import net.pricefx.restapiclient.model.BaseMap;

import java.math.BigDecimal;
import java.util.List;

import static net.pricefx.restapiclient.PfxClient.DEFAULT_OBJECT_MAPPER;

public class BaseMapNullable extends BaseMap {
    public BaseMapNullable() {
    }

    public ObjectNode toNode() {
        return DEFAULT_OBJECT_MAPPER.convertValue(this, ObjectNode.class);
    }


    public static <T> T fromObject(Object object, Class<T> clazz) {
        return DEFAULT_OBJECT_MAPPER.convertValue(object, clazz);
    }

    public void setStringValue(String property, String value) {
        if (value == null) {
            remove(property);
        } else {
            put(property, value);
        }
    }

    public void setIntegerValue(String property, Integer value) {
        if (value == null) {
            remove(property);
        } else {
            put(property, value);
        }
    }

    public void setLongValue(String property, Long value) {
        if (value == null) {
            remove(property);
        } else {
            put(property, value);
        }
    }

    public void setDecimalValue(String property, BigDecimal value) {
        if (value == null) {
            remove(property);
        } else {
            put(property, value);
        }
    }

    public void setBooleanValue(String property, Boolean value) {
        if (value == null) {
            remove(property);
        } else {
            put(property, value);
        }
    }

    public void setMapValue(String property, BaseMap value) {
        if (value == null) {
            remove(property);
        } else {
            put(property, value);
        }
    }

    public void setListValue(String property, List value) {
        if (value == null) {
            remove(property);
        } else {
            put(property, value);
        }
    }
}
